/* Vargr word generator -- Copyright by David Boddie (dboddie@uafhp.uark.edu) */
/* Consent is granted to copy this code and change it however you wish, how   */
/* ever, if you wish to sell it, you will have to write me..                  */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "vmain.c"
#include "vcon1.c"
#include "vvow.c"
#include "vcon2.c"
 
#define DIE     6
#define CONS    'C'
#define VOW     'V'
 
char *string[6], *wordstring;
char rc, *ptr;
int syllen;
int Random();
char *GetICons();
char *GetFCons();
char *GetVow();
 
main(argc,argv)
int argc;
char *argv[];
{
        int red, white, i, j, count, maxsyl;
        static int syllables;
 
        if(argc >= 2)   {
                srand(time(0L));
                for(count=0;count<atoi(argv[1]);count++)        {
                        syllables = (int) Random(DIE);
                        if(argv[2] != NULL)
                                maxsyl = atoi(argv[2]);
                        if(maxsyl > 0 && maxsyl <= 6)
                                syllables = maxsyl;
                        for (i=0; i<syllables; i++)     {
                                red = Random(DIE) - 1;
                                white = Random(DIE) - 1;
                                if(i != 0)
                                        rc = *(string[i-1]+strlen(string[i-1])-1);
                                if(i==0 || rc == CONS) {
                                        string[i] = basic[red][white];
                                        }
                                else    {
                                        string[i] = alt[red][white];
                                        }
                        } /* End of Loop */
                        string[i] = '\0';
                        wordstring = malloc((syllables * 9)+1);
                        *wordstring = '\0';
                        for(i=0;i<syllables;i++)        {
                                syllen = strlen(string[i]);
                                for(j=0;j<syllen;j++)   {
                                        rc = *(string[i]+j);
                                        if(j==0 && rc == CONS)  {
                                                red = Random(DIE);
                                                ptr = GetICons(red);
                                                strcat(wordstring,ptr);
                                        }
                                        else if(j != 0 && rc == CONS)   {
                                                red = Random(DIE);
                                                ptr = GetFCons(red);
                                                strcat(wordstring,ptr);
                                        }
                                        if(rc == VOW)   {
                                                red = Random(DIE);
                                                ptr = GetVow(red);
                                                strcat(wordstring,ptr);
                                        }
                                }
                        }
                        printf("%s\n",wordstring);
                        *wordstring = '\0';
                }
        }
        else    {
                printf("Usage: vargr number-of-names [maximum syllables]\n");
                }
} /* End of Main */
 
int Random(max)
int max;
{
        int die;
 
        die = ((int)(rand()%max)+1);
        return(die);
} /* End of Random */
 
char *GetICons(num)
int num;
{
        int r, w;
        char *grab;
 
        r = Random(DIE) - 1;
        w = Random(DIE) - 1;
        switch(num)     {
                case 1: grab = init1[r][w];
                        break;
                case 2: grab = init2[r][w];
                        break;
                case 3: grab = init3[r][w];
                        break;
                case 4: grab = init4[r][w];
                        break;
                case 5: grab = init5[r][w];
                        break;
                case 6: grab = init6[r][w];
                        break;
        }
        return(grab);
} /* End of GetICons */
 
char *GetFCons(num)
int num;
{
        int r, w;
        char *grab;
 
        r = Random(DIE) - 1;
        w = Random(DIE) - 1;
        switch(num)     {
                case 1: grab = final1[r][w];
                        break;
                case 2: grab = final2[r][w];
                        break;
                case 3: grab = final3[r][w];
                        break;
                case 4: grab = final4[r][w];
                        break;
                case 5: grab = final5[r][w];
                        break;
                case 6: grab = final6[r][w];
                        break;
        }
        return(grab);
} /* End of GetFCons */
 
char *GetVow(num)
int num;
{
        int r, w;
        char *grab;
 
        r = Random(DIE) - 1;
        w = Random(DIE) - 1;
        switch(num)     {
                case 1: grab = vow1[r][w];
                        break;
                case 2: grab = vow2[r][w];
                        break;
                case 3: grab = vow3[r][w];
                        break;
                case 4: grab = vow4[r][w];
                        break;
                case 5: grab = vow5[r][w];
                        break;
                case 6: grab = vow6[r][w];
                        break;
        }
        return(grab);
} /* End of GetVow */
